# [Bosses Helper](README.md): [Lua Helper Functions](boss_helper_functions.md#bosses-helper-lua-helper-functions) Layout

## [Entity Adding](boss_helper_functions.md#entity-adding)

- [helpers.addEntity (entity)](boss_helper_functions.md#helpersaddentity-entity)
- [helpers.destroyEntity (entity)](boss_helper_functions.md#helpersdestroyentity-entity)
- [helpers.destroyAll ()](boss_helper_functions.md#helpersdestroyall-)

## [Fight Logic](boss_helper_functions.md#fight-logic)

- [helpers.playPuppetAnim (anim)](boss_helper_functions.md#helpersplaypuppetanim-anim)
- [helpers.playAndWaitPuppetAnim (anim)](boss_helper_functions.md#helpersplayandwaitpuppetanim-anim)
- [helpers.seededRandom ()](boss_helper_functions.md#helpersseededrandom-)
- [helpers.getHealth ()](boss_helper_functions.md#helpersgethealth-)
- [helpers.setHealth (health)](boss_helper_functions.md#helperssethealth-health)
- [helpers.decreaseHealth ([health=1])](boss_helper_functions.md#helpersdecreasehealth-health1)
- [helpers.waitForAttackToEnd ()](boss_helper_functions.md#helperswaitforattacktoend-)
- [helpers.interruptPattern ()](boss_helper_functions.md#helpersinterruptpattern-)
- [helpers.getCurrentPatternID ()](boss_helper_functions.md#helpersgetcurrentpatternid-)
- [helpers.startAttackPattern ([goTo=-1])](boss_helper_functions.md#helpersstartattackpattern-goto-1)
- [helpers.startNextAttackPattern ()](boss_helper_functions.md#helpersstartnextattackpattern-)
- [helpers.forceNextAttackIndex (index)](boss_helper_functions.md#helpersforcenextattackindex-index)
- [helpers.savePhaseChangeToSession (health, index[, startImmediately=true])](boss_helper_functions.md#helperssavephasechangetosession-health-index-startimmediatelytrue)
- [helpers.removeBoss (permanent)](boss_helper_functions.md#helpersremoveboss-permanent)

## [Position and Movement](boss_helper_functions.md#position-and-movement)

- [helpers.setEffectiveGravityMult (mult)](boss_helper_functions.md#helpersseteffectivegravitymult-mult)
- [helpers.setGroundFriction (friction)](boss_helper_functions.md#helperssetgroundfriction-friction)
- [helpers.setAirFriction (friction)](boss_helper_functions.md#helperssetairfriction-friction)
- [helpers.setXSpeed (value)](boss_helper_functions.md#helperssetxspeed-value)
- [helpers.setYSpeed (value)](boss_helper_functions.md#helperssetyspeed-value)
- [helpers.setSpeed (x, y)](boss_helper_functions.md#helperssetspeed-x-y)
- [helpers.setXSpeedDuring (value, time)](boss_helper_functions.md#helperssetxspeedduring-value-time)
- [helpers.setYSpeedDuring (value, time)](boss_helper_functions.md#helperssetyspeedduring-value-time)
- [helpers.setSpeedDuring (x, y, time)](boss_helper_functions.md#helperssetspeedduring-x-y-time)
- [helpers.keepXSpeedDuring (time)](boss_helper_functions.md#helperskeepxspeedduring-time)
- [helpers.keepYSpeedDuring (time)](boss_helper_functions.md#helperskeepyspeedduring-time)
- [helpers.keepSpeedDuring (time)](boss_helper_functions.md#helperskeepspeedduring-time)
- [helpers.positionTween (target, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helperspositiontween-target-time-easernil-invertfalse)
- [helpers.speedXTween (start, target, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helpersspeedxtween-start-target-time-easernil-invertfalse)
- [helpers.speedYTween (start, target, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helpersspeedytween-start-target-time-easernil-invertfalse)
- [helpers.speedTween (xStart, xTarget, yStart, yTarget, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helpersspeedtween-xstart-xtarget-ystart-ytarget-time-easernil-invertfalse)
- [helpers.speedXTweenTo (target, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helpersspeedxtweento-target-time-easernil-invertfalse)
- [helpers.speedYTweenTo (target, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helpersspeedytweento-target-time-easernil-invertfalse)
- [helpers.speedTweenTo (xTarget, yTarget, time[, easer=nil[, invert=false]])](boss_helper_functions.md#helpersspeedtweento-xtarget-ytarget-time-easernil-invertfalse)

## [Collisions and Colliders](boss_helper_functions.md#collisions-and-colliders)

- [helpers.enableCollisions ()](boss_helper_functions.md#helpersenablecollisions-)
- [helpers.disableCollisions ()](boss_helper_functions.md#helpersdisablecollisions-)
- [helpers.enableSolidCollisions ()](boss_helper_functions.md#helpersenablesolidcollisions-)
- [helpers.disableSolidCollisions ()](boss_helper_functions.md#helpersdisablesolidcollisions-)
- [helpers.setHitCooldown (value)](boss_helper_functions.md#helperssethitcooldown-value)
- [helpers.resetHitCooldown ()](boss_helper_functions.md#helpersresethitcooldown-)
- [helpers.changeBaseHitboxTo (tag)](boss_helper_functions.md#helperschangebasehitboxto-tag)
- [helpers.changeHurtboxTo (tag)](boss_helper_functions.md#helperschangehurtboxto-tag)
- [helpers.changeBounceboxTo (tag)](boss_helper_functions.md#helperschangebounceboxto-tag)
- [helpers.changeTargetTo (tag)](boss_helper_functions.md#helperschangetargetto-tag)
- [helpers.getHitbox (width, height[, x=0[, y=0]])](boss_helper_functions.md#helpersgethitbox-width-height-x0-y0)
- [helpers.getCircle (radius[, x=0[, y=0]])](boss_helper_functions.md#helpersgetcircle-radius-x0-y0)
- [helpers.getColliderList (...)](boss_helper_functions.md#helpersgetcolliderlist-)

## [Boss Components and Entities](boss_helper_functions.md#boss-components-and-entities)

- [helpers.addComponentToBoss (component)](boss_helper_functions.md#helpersaddcomponenttoboss-component)
- [helpers.addConstantBackgroundCoroutine (func, ...)](boss_helper_functions.md#helpersaddconstantbackgroundcoroutine-func-)
- [helpers.getEntityChecker (checker[, func=helpers.destroyEntity[, state=true[, remove=true]]])](boss_helper_functions.md#helpersgetentitychecker-checker-funchelpersdestroyentity-statetrue-removetrue)
- [helpers.getEntityTimer (timer[, func=helpers.destroyEntity])](boss_helper_functions.md#helpersgetentitytimer-timer-funchelpersdestroyentity)
- [helpers.getEntityFlagger (flag[, func=helpers.destroyEntity[, state=true[, resetFlag=true]]])](boss_helper_functions.md#helpersgetentityflagger-flag-funchelpersdestroyentity-statetrue-resetflagtrue)
- [helpers.getEntityChain (entity[, startChained=true[, remove=false]])](boss_helper_functions.md#helpersgetentitychain-entity-startchainedtrue-removefalse)
- [helpers.getNewBasicAttackEntity (position, hitboxes, spriteName[, startCollidable=true[, funcOnPlayer=killPlayer[, xScale=1[, yScale=1]]]])](boss_helper_functions.md#helpersgetnewbasicattackentity-position-hitboxes-spritename-startcollidabletrue-funconplayerkillplayer-xscale1-yscale1)
- [helpers.getNewBasicAttackActor (position, hitboxes, spriteName[, gravMult=1[, maxFall=90[, startCollidable=true[, startSolidCollidable=true[, funcOnPlayer=killPlayer[, xScale=1[, yScale=1]]]]]]])](boss_helper_functions.md#helpersgetnewbasicattackactor-position-hitboxes-spritename-gravmult1-maxfall90-startcollidabletrue-startsolidcollidabletrue-funconplayerkillplayer-xscale1-yscale1)

## [Component Retreival](boss_helper_functions.md#component-retreival)

- [helpers.getComponents (name[, prefix])](boss_helper_functions.md#helpersgetcomponents-name-prefix)
- [helpers.getComponent (name[, prefix])](boss_helper_functions.md#helpersgetcomponent-name-prefix)
- [helpers.getAllComponents (name[, prefix])](boss_helper_functions.md#helpersgetallcomponents-name-prefix)
- [helpers.getFirstComponent (name[, prefix])](boss_helper_functions.md#helpersgetfirstcomponent-name-prefix)
- [helpers.getAllComponentsOnType (name, entity[, prefix[, entityPre]])](boss_helper_functions.md#helpersgetallcomponentsontype-name-entity-prefix-entitypre)
- [helpers.getFirstComponentOnType (name, entity[, prefix[, entityPre]])](boss_helper_functions.md#helpersgetfirstcomponentontype-name-entity-prefix-entitypre)
- [helpers.getComponentsFromEntity (entity, name[, prefix])](boss_helper_functions.md#helpersgetcomponentsfromentity-entity-name-prefix)
- [helpers.getComponentFromEntity (entity, name[, prefix])](boss_helper_functions.md#helpersgetcomponentfromentity-entity-name-prefix)
- [helpers.entityHasComponent (entity, name[, prefix])](boss_helper_functions.md#helpersentityhascomponent-entity-name-prefix)

## [Health System](boss_helper_functions.md#health-system)

- [helpers.getPlayerHealth ()](boss_helper_functions.md#helpersgetplayerhealth-)
- [helpers.giveInvincibleFrames (time)](boss_helper_functions.md#helpersgiveinvincibleframes-time)

## [Misc. Functions](boss_helper_functions.md#misc-functions)

- [helpers.sayExt (dialog, ...)](boss_helper_functions.md#helperssayext-dialog-)
- [helpers.getNewEntityData (position[, width=0[, height=0[, id=1000]]])](boss_helper_functions.md#helpersgetnewentitydata-position-width0-height0-id1000)
- [helpers.setEntityDataAttributes (entityData)](boss_helper_functions.md#helperssetentitydataattributes-entitydata)
- [helpers.storeObjectInBoss (key, object)](boss_helper_functions.md#helpersstoreobjectinboss-key-object)
- [helpers.getStoredObjectFromBoss (key)](boss_helper_functions.md#helpersgetstoredobjectfromboss-key)
- [helpers.deleteStoredObjectFromBoss (key)](boss_helper_functions.md#helpersdeletestoredobjectfromboss-key)
- [helpers.doMethodAfterDelay (func, delay)](boss_helper_functions.md#helpersdomethodafterdelay-func-delay)
- [helpers.v2L (vector)](boss_helper_functions.md#helpersv2l-vector)
- [helpers.normalize (vector[, length=1])](boss_helper_functions.md#helpersnormalize-vector-length1)
- [helpers.getEaserByName ([name[, invert]])](boss_helper_functions.md#helpersgeteaserbyname-name-invert)
